using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using CsOde;

namespace XnaRagdoll
{
    public class Main : Microsoft.Xna.Framework.Game
    {
        #region field
        GraphicsDeviceManager graphics = null;
        private Camera camera = null;

        /// <summary>GtFNg</summary>
        private Effect effects = null;
        /// <summary>_W</summary>
        private Vector4 lightPos;
        /// <summary>Pʗ̃fie 1cmC_Sj</summary>
        Model cubeModel = null;
        /// <summary>Pʋfia 1cmC_Sj</summary>
        Model sphereModel = null;

        /// <summary>nʃWIg</summary>
        private PhysicalGround ground = null;
        /// <summary>Oh[̃[g</summary>
        private ArticulatedBodyNode ragdollRoot = null;
        #endregion

        public Main()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            camera = new Camera(this);
            Components.Add(camera);
        }

        /// <summary>
        /// {Iȏ
        /// </summary>
        protected override void Initialize()
        {
            Physics.Create(new Vector3(0, -9.8e2f, 0));
            
            base.Initialize();
        }

        /// <summary>
        /// Reg̓ǂݍ
        /// </summary>
        protected override void LoadContent()
        {
            cubeModel = Content.Load<Model>(@"Models\cube600");
            sphereModel = Content.Load<Model>(@"Models\sphere400");

            LoadEffect();
            CreateModel();
        }

        /// <summary>
        /// nʂƑ֐߃Nn̍\z
        /// </summary>
        protected void CreateModel()
        {
            ground = new PhysicalGround(new Vector4(0, 1.0f, 0, 0));

            PhysicalBox boxBody = null;
            PhysicalSphere sphereBody = null;
            ArticulatedBodyNode parent = null, child = null;

            // 
            boxBody = new PhysicalBox(10.0f, cubeModel, new Vector3(20.0f, 40.0f, 10.0f));
            boxBody.Position = new Vector3(0, 110.0f, 0);
            ragdollRoot = new ArticulatedBodyNode(boxBody);

            // 
            sphereBody = new PhysicalSphere(5.0f, sphereModel, 10.0f);
            sphereBody.Position = new Vector3(0, 145.0f, 0);
            child = new ArticulatedBodyNode(sphereBody);
            child.ConnectByUniversal(ragdollRoot, new Vector3(0, 132.5f, 0),
                                    Vector3.UnitX, new float[2] { -MathHelper.Pi / 3.0f, MathHelper.Pi / 3.0f },
                                    Vector3.UnitZ, new float[2] { -MathHelper.Pi / 3.0f, MathHelper.Pi / 3.0f });

            // r
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(20.0f, 5.0f, 5.0f));
            boxBody.Position = new Vector3(25.0f, 130.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByUniversal(ragdollRoot, new Vector3(12.5f, 130.0f, 0),
                                    Vector3.UnitY, new float[2] { -MathHelper.Pi / 4.0f, MathHelper.Pi * 0.7f },
                                    Vector3.UnitZ, new float[2] { -MathHelper.Pi * 0.5f, MathHelper.Pi * 0.5f });
            parent = child;

            // Or
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(20.0f, 4.0f, 4.0f));
            boxBody.Position = new Vector3(50.0f, 130.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByHinge(parent, new Vector3(37.5f, 130.0f, 0), Vector3.UnitY, new float[2] { 0, MathHelper.Pi * 0.7f});


            // Er
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(20.0f, 5.0f, 5.0f));
            boxBody.Position = new Vector3(-25.0f, 130.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByUniversal(ragdollRoot, new Vector3(-12.5f, 130.0f, 0),
                                    Vector3.UnitY, new float[2] { -MathHelper.Pi * 0.7f, MathHelper.Pi / 4.0f },
                                    Vector3.UnitZ, new float[2] { -MathHelper.Pi * 0.5f, MathHelper.Pi * 0.5f });
            parent = child;

            // EOr
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(20.0f, 4.0f, 4.0f));
            boxBody.Position = new Vector3(-50.0f, 130.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByHinge(parent, new Vector3(-37.5f, 130.0f, 0), Vector3.UnitY, new float[2] { -MathHelper.Pi * 0.7f, 0 });


            // 
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(10.0f, 20.0f, 10.0f));
            boxBody.Position = new Vector3(7.5f, 75.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByUniversal(ragdollRoot, new Vector3(7.5f, 87.5f, 0),
                                    Vector3.UnitX, new float[2]{-MathHelper.Pi * 0.1f, MathHelper.Pi * 0.8f},
                                    Vector3.UnitZ, new float[2]{-MathHelper.Pi * 0.1f, MathHelper.Pi * 0.4f});
            parent = child;

            // 
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(8.0f, 20.0f, 8.0f));
            boxBody.Position = new Vector3(7.5f, 50.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByHinge(parent, new Vector3(7.5f, 62.5f, 0), Vector3.UnitX, new float[2] { -MathHelper.Pi * 0.7f, 0 });


            // E
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(10.0f, 20.0f, 10.0f));
            boxBody.Position = new Vector3(-7.5f, 75.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByUniversal(ragdollRoot, new Vector3(-7.5f, 87.5f, 0),
                                    Vector3.UnitX, new float[2] { -MathHelper.Pi * 0.1f, MathHelper.Pi * 0.8f },
                                    Vector3.UnitZ, new float[2] { -MathHelper.Pi * 0.4f, MathHelper.Pi * 0.1f });
            parent = child;

            // E
            boxBody = new PhysicalBox(5.0f, cubeModel, new Vector3(8.0f, 20.0f, 8.0f));
            boxBody.Position = new Vector3(-7.5f, 50.0f, 0);
            child = new ArticulatedBodyNode(boxBody);
            child.ConnectByHinge(parent, new Vector3(-7.5f, 62.5f, 0), Vector3.UnitX, new float[2] { -MathHelper.Pi * 0.7f, 0 });
        }

        /// <summary>
        /// GtFNgReg̓ǂݍ
        /// </summary>
        protected void LoadEffect()
        {
            effects = Content.Load<Effect>(@"Effect\BasicShader");

            lightPos = Vector4.UnitY;
            lightPos *= 2000.0f;
            lightPos.W = 1.0f;
            effects.Parameters["globalLightPos"].SetValue(lightPos);
        }

        /// <summary>
        /// RegjɃt[[NĂ΂郁\bh
        /// </summary>
        protected override void UnloadContent()
        {
            Physics.Destroy();
        }

        /// <summary>
        /// ԂXV邽߂Ƀt[[NĂ΂郁\bh
        /// </summary>
        /// <param name="gameTime"></param>
        protected override void Update(GameTime gameTime)
        {
            // ꂽL[ɉāÃ{fBɗ͂i͂̕j
            KeyboardState keyboardState = Keyboard.GetState();
            Keys[] pressedKeys = keyboardState.GetPressedKeys();
            foreach (Keys key in pressedKeys)
            {
                switch (key)
                {
                    case Keys.Up:
                        Ode.BodyAddForce(ragdollRoot.Bone.Body, 0, 1.0e2f, -2.0e5f);
                        break;
                    case Keys.Down:
                        Ode.BodyAddForce(ragdollRoot.Bone.Body, 0, 1.0e2f, 2.0e5f);
                        break;
                    case Keys.Right:
                        Ode.BodyAddForce(ragdollRoot.Bone.Body, 2.0e5f, 1.0e2f, 0);
                        break;
                    case Keys.Left:
                        Ode.BodyAddForce(ragdollRoot.Bone.Body, -2.0e5f, 1.0e2f, 0);
                        break;
                }
            }

            Physics.Step(1.0e-2f, Physics.DefaultCollisionCallback);

            effects.Parameters["viewProj"].SetValue(camera.View * camera.Projection);
            base.Update(gameTime);
        }

        /// <summary>
        /// ʍĕ`̂߃t[[NĂ΂郁\bh
        /// </summary>
        /// <param name="gameTime">oߎԓ̎ԏi[NX</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            Stack<ArticulatedBodyNode> stack = new Stack<ArticulatedBodyNode>();

            stack.Push(ragdollRoot);
            while (stack.Count > 0)
            {
                ArticulatedBodyNode node = stack.Pop();
                Matrix wm = node.Bone.ScaleTransform * node.Bone.Coordinate;

                effects.CurrentTechnique = effects.Techniques["PhongShader"];
                DrawModel(node.Bone.Model, wm);
                effects.CurrentTechnique = effects.Techniques["PlaneShadowShader"];
                DrawModel(node.Bone.Model, wm);

                for (int i = 0; i < node.NumChildren; ++i)
                    stack.Push(node.GetChild(i));
            }

            base.Draw(gameTime);
        }

        /// <summary>
        /// [h/r[/vWFNVgXtH[ˑ̃GtFNgp[^̍XV
        /// </summary>
        /// <param name="world">[hgXtH[s</param>
        protected void UpdateWorldDependedEffectParameters(Matrix world)
        {
            effects.Parameters["world"].SetValue(world);
            effects.Parameters["worldViewProj"].SetValue(world * camera.View * camera.Projection);

            Matrix invWorld = Matrix.Invert(world);
            Vector4 eye = camera.GetEyePosition();
            eye = Vector4.Transform(eye, invWorld);
            effects.Parameters["localEyePos"].SetValue(eye);

            Vector4 light = lightPos;
            light = Vector4.Transform(light, invWorld);
            effects.Parameters["localLightPos"].SetValue(light);
        }

        /// <summary>
        /// f̕`
        /// </summary>
        /// <param name="model">f</param>
        /// <param name="world">[hgXtH[s</param>
        protected void DrawModel(Model model, Matrix world)
        {
            Matrix[] transforms = new Matrix[model.Bones.Count];
            model.CopyAbsoluteBoneTransformsTo(transforms);

            foreach (ModelMesh mesh in model.Meshes)
            {
                Matrix wm = transforms[mesh.ParentBone.Index] * world;
                UpdateWorldDependedEffectParameters(wm);

                graphics.GraphicsDevice.Indices = mesh.IndexBuffer;
                foreach (ModelMeshPart meshPart in mesh.MeshParts)
                {
                    graphics.GraphicsDevice.Vertices[0].SetSource(mesh.VertexBuffer, meshPart.StreamOffset, meshPart.VertexStride);
                    graphics.GraphicsDevice.VertexDeclaration = meshPart.VertexDeclaration;

                    effects.Begin();
                    foreach (EffectPass pass in effects.CurrentTechnique.Passes)
                    {
                        pass.Begin();
                        graphics.GraphicsDevice.DrawIndexedPrimitives(
                            PrimitiveType.TriangleList, meshPart.BaseVertex, 0,
                            meshPart.NumVertices, meshPart.StartIndex, meshPart.PrimitiveCount);
                        pass.End();
                    }
                    effects.End();
                }
            }
        }
    }

    #region entry point
    /// <summary>
    /// entry point
    /// </summary>
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        static void Main(string[] args)
        {
            using (Main game = new Main())
            {
                game.Run();
            }
        }
    }
    #endregion
}
